/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: start.S 7391 2013-04-17 00:44:27Z yeom $
 */

/*
 *		ͥбΥȥåץ⥸塼Nios2ѡ
 */

#define OMIT_INCLUDE_OS_CFG		/* Os_Cfg.h󥯥롼޻ */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ̵ޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */
#include "kernel_impl.h"
#include "prc_asm.inc"

	 .section .entry, "xa"
	 .global __reset
	 .balign  FUNCTION_ALIGN_SIZE
__reset:
#if NIOS2_ICACHE_SIZE > 0
	/*
	 * The assumption here is that the instruction cache size is always
	 * a power of two.
	 */

#if NIOS2_ICACHE_SIZE > 0x8000
	movhi r2, %hi(NIOS2_ICACHE_SIZE)
#else
	movui r2, NIOS2_ICACHE_SIZE
#endif
0:
	initi r2
	addi r2, r2, -NIOS2_ICACHE_LINE_SIZE
	bgt r2, zero, 0b
1:

	.pushsection .debug_alt_sim_info
	.int 1, 1, 0b, 1b
	.popsection
#endif /* NIOS2_ICACHE_SIZE > 0 */

#ifndef BOOT_ROM
	movia r3, start
	jmp r3
#else
	br _boot_rom
#endif  /* BOOT_ROM */


#ifdef BOOT_ROM
	.section .text
	.global _boot_rom
	.balign  FUNCTION_ALIGN_SIZE
	.type _boot_rom, @function
_boot_rom:
#if NIOS2_DCACHE_SIZE > 0
#if NIOS2_DCACHE_SIZE > 0x8000
	movhi r2, %hi(NIOS2_DCACHE_SIZE)
#else
	movui r2, NIOS2_DCACHE_SIZE
#endif
0:
	initd 0(r2)
	addi r2, r2, -NIOS2_DCACHE_LINE_SIZE
	bgt r2, zero, 0b
1:
	.pushsection .debug_alt_sim_info
	.int 2, 1, 0b, 1b
	.popsection
#endif /* NIOS2_DCACHE_SIZE > 0 */

_boot_rom_1:
	movia   r3, ROM_BASE	/* r3 source */
	movia   r4, RAM_BASE	/* r4 destination */
	movia   r2, _edata

_flash_copy:
	ldw     r5, 0(r3)
	addi    r3, r3, 1
	stw     r5, 0(r4)
	addi    r4, r4, 1
	bgeu    r2, r4, _flash_copy

	movia r2, start
	jmp   r2
	nop

#endif /* BOOT_ROM */

	.section .text
	.global start
	.balign  FUNCTION_ALIGN_SIZE
	.type start, @function
start:
#if NIOS2_DCACHE_SIZE > 0
#if NIOS2_DCACHE_SIZE > 0x8000
	movhi r2, %hi(NIOS2_DCACHE_SIZE)
#else
	movui r2, NIOS2_DCACHE_SIZE
#endif
0:
	initd 0(r2)
	addi r2, r2, -NIOS2_DCACHE_LINE_SIZE
	bgt r2, zero, 0b
1:
	.pushsection .debug_alt_sim_info
	.int 2, 1, 0b, 1b
	.popsection
#endif /* NIOS2_DCACHE_SIZE > 0 */

	/*
	 *  STATUS쥸ν߶ػߡ
	 */
	wrctl status, zero

	/*
	 * set up the global pointer.
	 */
	movia gp, _gp

	/*
	 *  å
	 */
	my_core_id r3
	slli  r3, r3, 2
	movhi   r4, %hiadj(_ostkpt_table)
	addi    r4, r4, %lo(_ostkpt_table)
	add     r2, r4, r3
	ldw     sp, 0(r2)

start_0:
	movia r2, _hardware_init_hook
	beq   zero, r2, start_1
	callr r2

start_1:
    
	/*
	 * TNUM_HWCOREʾIDΥOSư̵¥롼פ
	 */
	my_core_id r5
    movui r2, TNUM_HWCORE - 1
    bgtu  r5, r2, crt0_end
    
	/*
	 * Υͥǡΰν
	 * ΥΥͥǡΰΤߤ0ꥢ
	 */
	slli  r3, r5, 2
    movhi r4, %hiadj(jmp_tbl)
    addi  r4, r4, %lo(jmp_tbl)
    add   r4, r4, r3
    ldw   r4, 0(r4)
    jmp   r4	/* core1_clear: ʤɤ˥ */

	/* ץơ֥ */
	.balign 32
jmp_tbl:
	.word core0_clear
#if TNUM_HWCORE > 1
	.word core1_clear
#endif /* TNUM_HWCORE > 1 */
#if TNUM_HWCORE > 2
	.word core2_clear
#endif /* TNUM_HWCORE > 2 */
#if TNUM_HWCORE > 3
	.word core3_clear
#endif /* TNUM_HWCORE > 3 */

core0_clear:
	movhi r4, %hiadj(__data0_start)
	addi  r4, r4, %lo(__data0_start)

	movhi r2, %hiadj(__data0_end)
	addi  r2, r2, %lo(__data0_end)
	br    start_clear

#if TNUM_HWCORE > 1 
core1_clear:
	movhi r4, %hiadj(__data1_start)
	addi  r4, r4, %lo(__data1_start)

	movhi r2, %hiadj(__data1_end)
	addi  r2, r2, %lo(__data1_end)
	br	  start_clear
#endif /* TNUM_HWCORE > 1 */

#if TNUM_HWCORE > 2 
core2_clear:
	movhi r4, %hiadj(__data2_start)
	addi  r4, r4, %lo(__data2_start)

	movhi r2, %hiadj(__data2_end)
	addi  r2, r2, %lo(__data2_end)
	br	  start_clear
#endif /* TNUM_HWCORE > 2 */

#if TNUM_HWCORE > 3 
core3_clear:
	movhi r4, %hiadj(__data3_start)
	addi  r4, r4, %lo(__data3_start)

	movhi r2, %hiadj(__data3_end)
	addi  r2, r2, %lo(__data3_end)
	br    start_clear
#endif /* TNUM_HWCORE > 3 */


start_clear:
	beq   r4, r2, end_clear:
clear_loop:
	stw  zero, (r4)
	addi r4, r4, 4
	bltu r4, r2, clear_loop
end_clear:

	/*
	 *  ޥʳϽԤ
	 */
	my_core_id r3
	movui r2, OS_CORE_ID_MASTER
	bne   r2, r3, slave_start

	/*
	 *  ޥưѤߤꤹ
	 */
	movhi r2, %hiadj(MAGIC_START)
	addi  r2, r2, %lo(MAGIC_START)
	slli  r5, r3, 2
	movhi r4, %hiadj(SYSVER_REG5)
	addi  r4, r4, %lo(SYSVER_REG5)
	add   r4, r4, r5
	stw   r2, 0(r4)

	/*
	 * Clear bss.
	 */
	movia r3, __bss_start
	movia r2, __bss_end
	beq   r3, r2, start_3

start_2:
	stw  zero, (r3)
	addi r3, r3, 4
	bltu r3, r2, start_2

start_3:
	movia r2, _software_init_hook
	beq   zero, r2, start_4
	callr r2

start_4:
	call target_hardware_initialize
    call main	/* mainؿ->StartOS */

crt0_end:
	br crt0_end


	/*
	 *  ޥʳStartCoreԤ롼
	 *  (r3˥IDޤޤƤ)
	 */
slave_start:
	movhi r2, %hiadj(MAGIC_START)
	addi  r2, r2, %lo(MAGIC_START)
	slli  r5, r3, 2
	movhi r4, %hiadj(SYSVER_REG5)
	addi  r4, r4, %lo(SYSVER_REG5)
	add   r4, r4, r5
	ldw   r6, 0(r4)
	bne   r2, r6, slave_start

    br start_4

